class ProjectionBuilder
  def buildProjection

    model = Sketchup.active_model
    entities = model.active_entities
    selection = model.selection.first

    maxX = nil
    minX = nil
    maxY = nil
    minY = nil
    maxZ = nil
    minZ = nil

    entities.each do |entity|
      if entity.is_a? Sketchup::Face
        edges = entity.edges

        edges.each do |edge|
          vertices = edge.vertices
          if maxX.nil? || vertices[0].position.x > maxX
          maxX = vertices[0].position.x
          end
          if minX.nil?  || vertices[0].position.x < minX
          minX = vertices[0].position.x
          end
          if maxY.nil? || vertices[0].position.y > maxY
          maxY = vertices[0].position.y
          end
          if minY.nil? || vertices[0].position.y < minY
          minY = vertices[0].position.y
          end
          if maxZ.nil? || vertices[0].position.z > maxZ
          maxZ = vertices[0].position.z
          end
          if minZ.nil? || vertices[0].position.z < minZ
          minZ = vertices[0].position.z
          end
          if vertices[1].position.x > maxX
          maxX = vertices[1].position.x
          end
          if vertices[1].position.x < minX
          minX = vertices[1].position.x
          end
          if vertices[1].position.y > maxY
          maxY = vertices[1].position.y
          end
          if vertices[1].position.y < minY
          minY = vertices[1].position.y
          end
          if vertices[1].position.z > maxZ
          maxZ = vertices[1].position.z
          end
          if vertices[1].position.z < minZ
          minZ = vertices[1].position.z
          end
        end
      end
    end

    gap = "150mm".to_l
    margin = "100mm".to_l

    modelHeight = maxZ - minZ
    modelWidth = maxX - minX
    modelDepth = maxY - minY

    # draw plan
    entities.each do |entity|
      if entity.is_a? Sketchup::Face
        edges = entity.edges
        edges.each do |edge|
        # now have the necessary offsets

          edges.each do |edge|
            vertices = edge.vertices

            entities.add_line([margin + vertices[0].position.x - minX,0,margin + vertices[0].position.z],[margin + vertices[1].position.x - minX,0,margin + vertices[1].position.z])
            entities.add_line([margin + gap + modelWidth + vertices[0].position.y - minY,0,margin + vertices[0].position.z],[margin + gap + modelWidth + vertices[1].position.y - minY,0,margin + vertices[1].position.z])
            entities.add_line([margin + vertices[0].position.x - minX,0,margin + gap + modelHeight + vertices[0].position.y - minY],[margin + vertices[1].position.x - minX,0,margin + gap + modelHeight + vertices[1].position.y - minY])
          end
        end
      end
    end
  end
end

toolsmenu = UI.menu("Tools")
cmd = UI::Command.new("Build Projection") {
  aProjectionBuilder = ProjectionBuilder.new
  aProjectionBuilder.buildProjection
}
cmd.menu_text = "Build Projection"
toolsmenu.add_item cmd
puts cmd.menu_text
